import { Observable, Subject } from 'rxjs';
import { IProviderConnectionData, IConnectionData } from '../interfaces';
export interface IClientData {
    id: string;
    roles?: string[];
    permissionRecord?: string;
}
export declare class Client {
    private _connectionString;
    client: any;
    states$: Subject<any>;
    errors$: Subject<any>;
    private subscribtion;
    private errorSubscribtion;
    static GetDependencies(): {
        deepstream: any;
    };
    constructor(_connectionString: string, options?: any);
    login(authData: IProviderConnectionData | IConnectionData): Observable<IClientData>;
    close(): Observable<void>;
    isClosed(): boolean;
    isConnected(): boolean;
}
