import { Observable } from 'rxjs';
import { Client } from '../client';
import { Record } from '../record';
export interface IRecordAdded<T> {
    data: T;
    position: number;
}
export declare class List<T = any> {
    protected _client: Client;
    private _name;
    protected _list: any;
    constructor(_client: Client, _name: string);
    subscribeForEntries(): Observable<string[]>;
    subscribeForData(): Observable<T[]>;
    addEntry(entry: string, index?: number): void;
    removeEntry(entry: string, index?: number): void;
    addRecord(data: T, index?: number): Observable<void>;
    discard(): void;
    recordAdded(): Observable<IRecordAdded<T>>;
    isEmpty(): Observable<boolean>;
    protected _createRecord(recordName: string): Record<T>;
}
